/*******************************************************************************
 * FoxDataStore_OnlineStats generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDataStore_OnlineStats extends UIDataStore_OnlineStats
    transient
    native
    config(UI)
    hidecategories(Object,UIRoot);

struct native StatBasedAchievement
{
    var int AchievementId;
    var string AchievementName;
    var string BoundToStatName;
    var float ThresholdForUnlock;

    structdefaultproperties
    {
        AchievementId=0
        AchievementName=""
        BoundToStatName=""
        ThresholdForUnlock=0.0
    }
};

var private bool bStatsValid;
var private float SkillRating;
var private string MatchesStatName;
var private string WinPctStatName;
var private string KDRStatName;
var const config array<config StatBasedAchievement> StatBasedAchievements;

event bool RefreshStats(byte ControllerIndex)
{
    local array<UniqueNetId> Players;
    local UniqueNetId PlayerID;

    // End:0x1A
    if(bStatsValid)
    {
        TriggerReadCompleteDelegates(true);
        return true;
    }
    // End:0x49
    if(PlayerInterface.GetLoginStatus(0) != 2)
    {
        return true;
    }
    SetStatsReadInfo();
    StatsInterface.FreeStats(StatsRead);
    switch(CurrentReadType)
    {
        // End:0x117
        case 0:
            PlayerInterface.GetUniquePlayerId(ControllerIndex, PlayerID);
            Players[0] = PlayerID;
            // End:0x115
            if(StatsInterface.ReadOnlineStats(Players, StatsRead) == false)
            {
                return false;
            }
            return true;
        // End:0x15A
        case 1:
            // End:0x158
            if(StatsInterface.ReadOnlineStatsByRankAroundPlayer(ControllerIndex, StatsRead, 10) == false)
            {
                return false;
            }
            return true;
        // End:0x19D
        case 2:
            // End:0x19B
            if(StatsInterface.ReadOnlineStatsForFriends(ControllerIndex, StatsRead) == false)
            {
                return false;
            }
            return true;
        // End:0x1E0
        case 3:
            // End:0x1DE
            if(StatsInterface.ReadOnlineStatsByRank(ControllerIndex, StatsRead) == false)
            {
                return false;
            }
            return true;
        // End:0xFFFF
        default:
            //return ReturnValue;
    }
}
}

// Export UFoxDataStore_OnlineStats::execTriggerReadCompleteDelegates(FFrame&, void* const)
private native final function TriggerReadCompleteDelegates(bool bSuccess);

event InvalidateStats()
{
    bStatsValid = false;
    //return;    
}

function bool AreStatsValid()
{
    return bStatsValid;
    //return ReturnValue;    
}

function OnReadComplete(bool bWasSuccessful, array<string> ChangedStatNames)
{
    // End:0x10
    if(bStatsValid)
    {
    }
    // End:0x64
    else
    {
        // End:0x49
        if(bWasSuccessful)
        {
            bStatsValid = true;
            CalculateSkillRating();
            UnlockStatBasedAchievements(ChangedStatNames);
        }
        // End:0x64
        else
        {
            bStatsValid = false;
            SkillRating = 1.0;
        }
    }
    //return;    
}

private final function CalculateSkillRating()
{
    local FoxOnlineStats_PlayerStats MyOnlineStats;
    local float MatchCount, KDR, WinPct;
    local UniqueNetId MyNetID;

    MyOnlineStats = FoxOnlineStats_PlayerStats(StatsRead);
    PlayerInterface.GetUniquePlayerId(0, MyNetID);
    // End:0x129
    if(MyOnlineStats.GetNamedFloatStatValue(MyNetID, MatchesStatName, MatchCount))
    {
        // End:0x129
        if(MatchCount > 20.0)
        {
            MyOnlineStats.GetNamedFloatStatValue(MyNetID, WinPctStatName, WinPct);
            MyOnlineStats.GetNamedFloatStatValue(MyNetID, KDRStatName, KDR);
            SkillRating = KDR + WinPct;
        }
    }
    //return;    
}

function float GetSkillRating()
{
    return SkillRating;
    //return ReturnValue;    
}

// Export UFoxDataStore_OnlineStats::execUnlockStatBasedAchievements(FFrame&, void* const)
native function UnlockStatBasedAchievements(array<string> ChangedStatNames);

defaultproperties
{
    SkillRating=1.0
    MatchesStatName="matches_gt_gen"
    WinPctStatName="winpct_gt_gen"
    KDRStatName="kdr_global"
    StatBasedAchievements(0)=(AchievementId=1,AchievementName="mechanizedsoldier",BoundToStatName="dpt_aut_hsmg_kills",ThresholdForUnlock=50.0)
    StatBasedAchievements(1)=(AchievementId=3,AchievementName="breadwinner",BoundToStatName="total_gp_ever",ThresholdForUnlock=50000.0)
    StatBasedAchievements(2)=(AchievementId=7,AchievementName="whoneedsfriends",BoundToStatName="gt_dm_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(3)=(AchievementId=8,AchievementName="onelifetolive",BoundToStatName="gt_snd_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(4)=(AchievementId=9,AchievementName="teamplayer",BoundToStatName="gt_tdm_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(5)=(AchievementId=10,AchievementName="kleptomaniac",BoundToStatName="gt_ctf_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(6)=(AchievementId=11,AchievementName="nooneleftbehind",BoundToStatName="gt_kc_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(7)=(AchievementId=12,AchievementName="survivor",BoundToStatName="gt_os_matches",ThresholdForUnlock=20.0)
    StatBasedAchievements(8)=(AchievementId=17,AchievementName="thisisforshooting",BoundToStatName="ammobuys",ThresholdForUnlock=10.0)
    StatBasedAchievements(9)=(AchievementId=18,AchievementName="thisisforfun",BoundToStatName="tauntf_tot",ThresholdForUnlock=100.0)
    StatBasedAchievements(10)=(AchievementId=2,AchievementName="toasty",BoundToStatName="dpt_fla_hardsuitburnouts",ThresholdForUnlock=10.0)
    StatBasedAchievements(11)=(AchievementId=20,AchievementName="hardsuitautocannon",BoundToStatName="dpt_sni_hsac_kills",ThresholdForUnlock=50.0)
    StatBasedAchievements(12)=(AchievementId=22,AchievementName="reanimator",BoundToStatName="tac_syr_revivals",ThresholdForUnlock=10.0)
    StatsReadClasses=/* Array type was not detected. */
    Tag=FoxLeaderboard
}